/* ------------------------------------------------------------------ */
/*      item            : IndexPoint.hxx
        generated by    : Autobuild (abuild)
        date            : Fri 07 Mar 2025
        category        : header file
        description     : DUECA Communication Object (DCO)
                          automatically generated by dueca-codegen
        codegen version : 111
        language        : C++
        original item   : IndexPoint.dco
        made by         : Rene' van Paassen
        date            : 211022
        description     : Index marking for data log
        copyright       : (c) 2021-2022 TUDelft-AE-C&S
                        : (c) 2022 René van Paassen
        license         : EUPL-1.2
*/

#pragma once
#if !defined(__DCO_NOPACK)
namespace dueca {
class AmorphStore;
class AmorphReStore;
struct DataWriterArraySize;
};
#endif

#if !defined(__DCO_STANDALONE)
namespace dueca {
struct CommObjectDataTable;
};

#include <gencodegen.h>
#if GENCODEGEN != 111
#error "Generated IndexPoint.hxx too old, please clean with 'make mrproper'"
#endif
#include <dueca/CommObjectTraits.hxx>
#endif
#include <iostream>

#ifndef NESTED_DCO
#define NESTED_DCO
#define MASTER_DCO_IndexPoint
#endif
#include <inttypes.h>
#include <ddff_ns.h>
#ifdef MASTER_DCO_IndexPoint
#undef MASTER_DCO_IndexPoint
#undef NESTED_DCO
#endif

namespace dueca {
namespace  ddff {
 
/** Indicate where in the file buffers, a specific recording starts
    */
struct IndexPoint
{
  /** typedef for internal reference */
  typedef IndexPoint __ThisDCOType__;

public:
  /** The name of this class. */
  static const char* const classname;


  /** ID for the data stream */
  uint32_t dataid;

  /** File buffer and offset for this data  */
  uint64_t offset;

public:
  /** a "magic" number, hashed out of the class definition,
      that will be used to check consistency of the sent objects
      across the dueca nodes. */
  static const uint32_t magic_check_number;

  /** default constructor. */
  IndexPoint();

  /** Constructor with arguments */
  IndexPoint(
        const uint32_t& dataid,
        const uint64_t& offset);

  /** copy constructor. */
  IndexPoint(const IndexPoint& o);

#if !defined(__DCO_NOPACK)
  /** constructor to restore an IndexPoint from amorphous storage. */
  IndexPoint(::dueca::AmorphReStore& r);
#endif

  /** destructor. */
  ~IndexPoint();

#if !defined(__DCO_STANDALONE)
  /** new operator "new", which places objects not on a
      heap, but in one of the memory arenas. This to speed up
      memory management. */
  static void* operator new(size_t size);

  /** accompanying placement operator "new" */
  static void* operator new(size_t size, void* mem);

  /** new operator "delete", to go with the new version
      of operator new. */
  static void operator delete(void* p);

  /** placement "new", needed for stl. */
  inline static void* operator new(size_t size, IndexPoint*& o)
  { return reinterpret_cast<void*>(o); }
#endif

#if !defined(__DCO_NOPACK)
  /** packs the IndexPoint into amorphous storage. */
  void packData(::dueca::AmorphStore& s) const;

  /** packs the IndexPoint into amorphous storage.
      only differences with a previous object are packed. */
  void packDataDiff(::dueca::AmorphStore& s, const IndexPoint& ref) const;

  /** unpacks the IndexPoint from an amorphous storage. */
  void unPackData(::dueca::AmorphReStore& s);

  /** unpacks the differences for IndexPoint
      from an amorphous storage. */
  void unPackDataDiff(::dueca::AmorphReStore& s);
#endif

  /** Test for equality. */
  bool operator == (const IndexPoint& o) const;

  /** Test for inequality. */
  inline bool operator != (const IndexPoint& o) const
  { return !(*this == o); }

  /** Assignment operator. */
  IndexPoint& operator=(const IndexPoint& o);

  /** prints the IndexPoint to a stream. */
  std::ostream & print(std::ostream& s) const;
};

} } 

#if !defined(__DCO_NOPACK)
/** pack the object into amorphous storage. */
inline void packData(::dueca::AmorphStore& s,
                     const dueca:: ddff::IndexPoint& o)
{ o.packData(s); }

/** pack the differences between this object and another
    into amorphous storage. */
inline void packDataDiff(dueca::AmorphStore& s,
                         const dueca:: ddff::IndexPoint& o,
                         const dueca:: ddff::IndexPoint& ref)
{ o.packDataDiff(s, ref); }

/** unpack the object from amorphous storage. */
inline void unPackData(::dueca::AmorphReStore& s,
                       dueca:: ddff::IndexPoint& o)
{ o.unPackData(s); }

/** unpack the differences to this object from storage. */
inline void unPackDataDiff(dueca::AmorphReStore& s,
                           dueca:: ddff::IndexPoint& o)
{ o.unPackDataDiff(s); }
#endif

namespace std {
/** print to a stream. */
inline std::ostream &
operator << (std::ostream& s, const dueca:: ddff::IndexPoint& o)
{ return o.print(s); }
};

// specialization of classname
template<>
const char* dueca::getclassname<dueca:: ddff::IndexPoint>();
template <>
inline const char* dueca::getclassname<const dueca:: ddff::IndexPoint>()
{ return dueca::getclassname<dueca:: ddff::IndexPoint>(); }

#if !defined(__DCO_STANDALONE)
namespace dueca {
/** Template specialization, defines a trait that is needed if
    IndexPoint is ever used inside other dco objects. */
template <>
struct dco_nested<dueca:: ddff::IndexPoint> : public dco_isnested { };
};

#endif


