/* ------------------------------------------------------------------ */
/*      item            : DataTimeSpec.hxx
        generated by    : Autobuild (abuild)
        date            : Fri 07 Mar 2025
        category        : header file
        description     : DUECA Communication Object (DCO)
                          automatically generated by dueca-codegen
        codegen version : 111
        language        : C++
        item            : DataTimeSpec.dco
        made by         : Rene' van Paassen
        date            : 1301002
        documentation   : DUECA_API
        description     : split off this class from the original TimeSpec
                          file; auto generated (partially) to make fluently
                          packable
        copyright       : (c) 2016-2022 TUDelft-AE-C&S
                        : (c) 2022 René van Paassen
        license         : EUPL-1.2
*/

#pragma once
#if !defined(__DCO_NOPACK)
namespace dueca {
class AmorphStore;
class AmorphReStore;
struct DataWriterArraySize;
};
#endif

#if !defined(__DCO_STANDALONE)
namespace dueca {
struct CommObjectDataTable;
};

#include <gencodegen.h>
#if GENCODEGEN != 111
#error "Generated DataTimeSpec.hxx too old, please clean with 'make mrproper'"
#endif
#include <dueca/CommObjectTraits.hxx>
#endif
#include <iostream>
DUECA_NS_START;
typedef uint32_t TimeTickType;
class TimeSpec;
class PeriodicTimeSpec;
DUECA_NS_END;
#include <algorithm>
#ifndef NESTED_DCO
#define NESTED_DCO
#define MASTER_DCO_DataTimeSpec
#endif

#ifdef MASTER_DCO_DataTimeSpec
#undef MASTER_DCO_DataTimeSpec
#undef NESTED_DCO
#endif

namespace dueca {
 
/** DataTimeSpec is a special bare-bones version of TimeSpec. It is
    used for storage of the time specification with the data in
    channels. The advantage is that DataTimeSpec has no virtual
    functions and thus no virtual table pointer. This does not only
    make it smaller, but it also make the DataTimeSpec usable across a
    reflective/shared memory device where a virtual table pointer
    would be erroneous in all but one process.
    */
struct DataTimeSpec
{
  /** typedef for internal reference */
  typedef DataTimeSpec __ThisDCOType__;

public:
  /** The name of this class. */
  static const char* const classname;


  /** The time interval starts here */
  TimeTickType validity_start;

  /** The time interval ends <em>before</em> this */
  TimeTickType validity_end;

public:
  /** a "magic" number, hashed out of the class definition,
      that will be used to check consistency of the sent objects
      across the dueca nodes. */
  static const uint32_t magic_check_number;

  /** default constructor. */
  DataTimeSpec();

  /** Constructor with arguments */
  DataTimeSpec(
        const TimeTickType& validity_start,
        const TimeTickType& validity_end);

  /** copy constructor. */
  DataTimeSpec(const DataTimeSpec& o);

#if !defined(__DCO_NOPACK)
  /** constructor to restore an DataTimeSpec from amorphous storage. */
  DataTimeSpec(::dueca::AmorphReStore& r);
#endif

  /** destructor. */
  ~DataTimeSpec();

#if !defined(__DCO_STANDALONE)
  /** new operator "new", which places objects not on a
      heap, but in one of the memory arenas. This to speed up
      memory management. */
  static void* operator new(size_t size);

  /** accompanying placement operator "new" */
  static void* operator new(size_t size, void* mem);

  /** new operator "delete", to go with the new version
      of operator new. */
  static void operator delete(void* p);

  /** placement "new", needed for stl. */
  inline static void* operator new(size_t size, DataTimeSpec*& o)
  { return reinterpret_cast<void*>(o); }
#endif

#if !defined(__DCO_NOPACK)
  /** packs the DataTimeSpec into amorphous storage. */
  void packData(::dueca::AmorphStore& s) const;

  /** packs the DataTimeSpec into amorphous storage.
      only differences with a previous object are packed. */
  void packDataDiff(::dueca::AmorphStore& s, const DataTimeSpec& ref) const;

  /** unpacks the DataTimeSpec from an amorphous storage. */
  void unPackData(::dueca::AmorphReStore& s);

  /** unpacks the differences for DataTimeSpec
      from an amorphous storage. */
  void unPackDataDiff(::dueca::AmorphReStore& s);
#endif

  /** Test for equality. */
  bool operator == (const DataTimeSpec& o) const;

  /** Test for inequality. */
  inline bool operator != (const DataTimeSpec& o) const
  { return !(*this == o); }

  /** Assignment operator. */
  DataTimeSpec& operator=(const DataTimeSpec& o);

  /** prints the DataTimeSpec to a stream. */
  std::ostream & print(std::ostream& s) const;

// Additional custom code
#include "DataTimeSpecExtra.hxx"
};

} 

#if !defined(__DCO_NOPACK)
/** pack the object into amorphous storage. */
inline void packData(::dueca::AmorphStore& s,
                     const dueca::DataTimeSpec& o)
{ o.packData(s); }

/** pack the differences between this object and another
    into amorphous storage. */
inline void packDataDiff(dueca::AmorphStore& s,
                         const dueca::DataTimeSpec& o,
                         const dueca::DataTimeSpec& ref)
{ o.packDataDiff(s, ref); }

/** unpack the object from amorphous storage. */
inline void unPackData(::dueca::AmorphReStore& s,
                       dueca::DataTimeSpec& o)
{ o.unPackData(s); }

/** unpack the differences to this object from storage. */
inline void unPackDataDiff(dueca::AmorphReStore& s,
                           dueca::DataTimeSpec& o)
{ o.unPackDataDiff(s); }
#endif

namespace std {
/** print to a stream. */
inline std::ostream &
operator << (std::ostream& s, const dueca::DataTimeSpec& o)
{ return o.print(s); }
};

// specialization of classname
template<>
const char* dueca::getclassname<dueca::DataTimeSpec>();
template <>
inline const char* dueca::getclassname<const dueca::DataTimeSpec>()
{ return dueca::getclassname<dueca::DataTimeSpec>(); }

#if !defined(__DCO_STANDALONE)
namespace dueca {
/** Template specialization, defines a trait that is needed if
    DataTimeSpec is ever used inside other dco objects. */
template <>
struct dco_nested<dueca::DataTimeSpec> : public dco_isnested { };
};

#endif


