/* ------------------------------------------------------------------ */
/*      item            : EntityConfirm.hxx
        generated by    : Autobuild (abuild)
        date            : Fri 07 Mar 2025
        category        : header file
        description     : DUECA Communication Object (DCO)
                          automatically generated by dueca-codegen
        codegen version : 111
        language        : C++
        item            : EntityConfirm.dco
        made by         : Rene' van Paassen
        date            : 1301002
        description     : Control entity state machine
        copyright       : (c) 2016-2022 TUDelft-AE-C&S
                        : (c) 2022 René van Paassen
        license         : EUPL-1.2
*/

#pragma once
#if !defined(__DCO_NOPACK)
namespace dueca {
class AmorphStore;
class AmorphReStore;
struct DataWriterArraySize;
};
#endif

#if !defined(__DCO_STANDALONE)
namespace dueca {
struct CommObjectDataTable;
};

#include <gencodegen.h>
#if GENCODEGEN != 111
#error "Generated EntityConfirm.hxx too old, please clean with 'make mrproper'"
#endif
#include <dueca/CommObjectTraits.hxx>
#endif
#include <iostream>

#ifndef NESTED_DCO
#define NESTED_DCO
#define MASTER_DCO_EntityConfirm
#endif
#include <SimulationState.hxx>
#include <SnapshotState.hxx>
#include <SimTime.hxx>
#include <GlobalId.hxx>
#ifdef MASTER_DCO_EntityConfirm
#undef MASTER_DCO_EntityConfirm
#undef NESTED_DCO
#endif

namespace dueca {
 
/** EntityConfirm, for status feedback. \todo update this name!
    */
struct EntityConfirm
{
  /** typedef for internal reference */
  typedef EntityConfirm __ThisDCOType__;

public:
  /** The name of this class. */
  static const char* const classname;


  /** confirmation of the current state */
  SimulationState current_state;

  /** state of the snapshot machine */
  SnapshotState snap_state;

  /** time of last running of this module */
  TimeTickType last_check;

  /** origin, sender */
  GlobalId origin;

public:
  /** a "magic" number, hashed out of the class definition,
      that will be used to check consistency of the sent objects
      across the dueca nodes. */
  static const uint32_t magic_check_number;

  /** default constructor. */
  EntityConfirm();

  /** Constructor with arguments */
  EntityConfirm(
        const SimulationState& current_state,
        const SnapshotState& snap_state,
        const TimeTickType& last_check,
        const GlobalId& origin);

  /** copy constructor. */
  EntityConfirm(const EntityConfirm& o);

#if !defined(__DCO_NOPACK)
  /** constructor to restore an EntityConfirm from amorphous storage. */
  EntityConfirm(::dueca::AmorphReStore& r);
#endif

  /** destructor. */
  ~EntityConfirm();

#if !defined(__DCO_STANDALONE)
  /** new operator "new", which places objects not on a
      heap, but in one of the memory arenas. This to speed up
      memory management. */
  static void* operator new(size_t size);

  /** accompanying placement operator "new" */
  static void* operator new(size_t size, void* mem);

  /** new operator "delete", to go with the new version
      of operator new. */
  static void operator delete(void* p);

  /** placement "new", needed for stl. */
  inline static void* operator new(size_t size, EntityConfirm*& o)
  { return reinterpret_cast<void*>(o); }
#endif

#if !defined(__DCO_NOPACK)
  /** packs the EntityConfirm into amorphous storage. */
  void packData(::dueca::AmorphStore& s) const;

  /** packs the EntityConfirm into amorphous storage.
      only differences with a previous object are packed. */
  void packDataDiff(::dueca::AmorphStore& s, const EntityConfirm& ref) const;

  /** unpacks the EntityConfirm from an amorphous storage. */
  void unPackData(::dueca::AmorphReStore& s);

  /** unpacks the differences for EntityConfirm
      from an amorphous storage. */
  void unPackDataDiff(::dueca::AmorphReStore& s);
#endif

  /** Test for equality. */
  bool operator == (const EntityConfirm& o) const;

  /** Test for inequality. */
  inline bool operator != (const EntityConfirm& o) const
  { return !(*this == o); }

  /** Assignment operator. */
  EntityConfirm& operator=(const EntityConfirm& o);

  /** prints the EntityConfirm to a stream. */
  std::ostream & print(std::ostream& s) const;
};

} 

#if !defined(__DCO_NOPACK)
/** pack the object into amorphous storage. */
inline void packData(::dueca::AmorphStore& s,
                     const dueca::EntityConfirm& o)
{ o.packData(s); }

/** pack the differences between this object and another
    into amorphous storage. */
inline void packDataDiff(dueca::AmorphStore& s,
                         const dueca::EntityConfirm& o,
                         const dueca::EntityConfirm& ref)
{ o.packDataDiff(s, ref); }

/** unpack the object from amorphous storage. */
inline void unPackData(::dueca::AmorphReStore& s,
                       dueca::EntityConfirm& o)
{ o.unPackData(s); }

/** unpack the differences to this object from storage. */
inline void unPackDataDiff(dueca::AmorphReStore& s,
                           dueca::EntityConfirm& o)
{ o.unPackDataDiff(s); }
#endif

namespace std {
/** print to a stream. */
inline std::ostream &
operator << (std::ostream& s, const dueca::EntityConfirm& o)
{ return o.print(s); }
};

// specialization of classname
template<>
const char* dueca::getclassname<dueca::EntityConfirm>();
template <>
inline const char* dueca::getclassname<const dueca::EntityConfirm>()
{ return dueca::getclassname<dueca::EntityConfirm>(); }

#if !defined(__DCO_STANDALONE)
namespace dueca {
/** Template specialization, defines a trait that is needed if
    EntityConfirm is ever used inside other dco objects. */
template <>
struct dco_nested<dueca::EntityConfirm> : public dco_isnested { };
};

#endif


