/* ------------------------------------------------------------------ */
/*      item            : EntryCountResult.hxx
        generated by    : Autobuild (abuild)
        date            : Fri 07 Mar 2025
        category        : header file
        description     : DUECA Communication Object (DCO)
                          automatically generated by dueca-codegen
        codegen version : 111
        language        : C++
        item            : EntryCountResult.dco
        made by         : Rene' van Paassen
        date            : 180509
        description     : Return a count of entry writes/reads
        copyright       : (c) 2018-2022 TUDelft-AE-C&S
                        : (c) 2022 René van Paassen
        license         : EUPL-1.2
*/

#pragma once
#if !defined(__DCO_NOPACK)
namespace dueca {
class AmorphStore;
class AmorphReStore;
struct DataWriterArraySize;
};
#endif

#if !defined(__DCO_STANDALONE)
namespace dueca {
struct CommObjectDataTable;
};

#include <gencodegen.h>
#if GENCODEGEN != 111
#error "Generated EntryCountResult.hxx too old, please clean with 'make mrproper'"
#endif
#include <dueca/CommObjectTraits.hxx>
#endif
#include <iostream>

#ifndef NESTED_DCO
#define NESTED_DCO
#define MASTER_DCO_EntryCountResult
#endif
#include <ChannelDef.hxx>
#include <TokenCountResult.hxx>
#include <varvector.hxx>
typedef dueca::varvector<dueca::TokenCountResult> count_list;
#ifdef MASTER_DCO_EntryCountResult
#undef MASTER_DCO_EntryCountResult
#undef NESTED_DCO
#endif

namespace dueca {
 
/** An automatically generated class
    */
struct EntryCountResult
{
  /** typedef for internal reference */
  typedef EntryCountResult __ThisDCOType__;

public:
  /** The name of this class. */
  static const char* const classname;


  /** entry number */
  entryid_type entryid;

  /** list of counts, for reading or writing */
  count_list counts;

public:
  /** a "magic" number, hashed out of the class definition,
      that will be used to check consistency of the sent objects
      across the dueca nodes. */
  static const uint32_t magic_check_number;

  /** default constructor. */
  EntryCountResult();

  /** Constructor with arguments */
  EntryCountResult(
        const entryid_type& entryid,
        const count_list& counts);

  /** copy constructor. */
  EntryCountResult(const EntryCountResult& o);

#if !defined(__DCO_NOPACK)
  /** constructor to restore an EntryCountResult from amorphous storage. */
  EntryCountResult(::dueca::AmorphReStore& r);
#endif

  /** destructor. */
  ~EntryCountResult();

#if !defined(__DCO_STANDALONE)
  /** new operator "new", which places objects not on a
      heap, but in one of the memory arenas. This to speed up
      memory management. */
  static void* operator new(size_t size);

  /** accompanying placement operator "new" */
  static void* operator new(size_t size, void* mem);

  /** new operator "delete", to go with the new version
      of operator new. */
  static void operator delete(void* p);

  /** placement "new", needed for stl. */
  inline static void* operator new(size_t size, EntryCountResult*& o)
  { return reinterpret_cast<void*>(o); }
#endif

#if !defined(__DCO_NOPACK)
  /** packs the EntryCountResult into amorphous storage. */
  void packData(::dueca::AmorphStore& s) const;

  /** packs the EntryCountResult into amorphous storage.
      only differences with a previous object are packed. */
  void packDataDiff(::dueca::AmorphStore& s, const EntryCountResult& ref) const;

  /** unpacks the EntryCountResult from an amorphous storage. */
  void unPackData(::dueca::AmorphReStore& s);

  /** unpacks the differences for EntryCountResult
      from an amorphous storage. */
  void unPackDataDiff(::dueca::AmorphReStore& s);
#endif

  /** Test for equality. */
  bool operator == (const EntryCountResult& o) const;

  /** Test for inequality. */
  inline bool operator != (const EntryCountResult& o) const
  { return !(*this == o); }

  /** Assignment operator. */
  EntryCountResult& operator=(const EntryCountResult& o);

  /** prints the EntryCountResult to a stream. */
  std::ostream & print(std::ostream& s) const;
};

} 

#if !defined(__DCO_NOPACK)
/** pack the object into amorphous storage. */
inline void packData(::dueca::AmorphStore& s,
                     const dueca::EntryCountResult& o)
{ o.packData(s); }

/** pack the differences between this object and another
    into amorphous storage. */
inline void packDataDiff(dueca::AmorphStore& s,
                         const dueca::EntryCountResult& o,
                         const dueca::EntryCountResult& ref)
{ o.packDataDiff(s, ref); }

/** unpack the object from amorphous storage. */
inline void unPackData(::dueca::AmorphReStore& s,
                       dueca::EntryCountResult& o)
{ o.unPackData(s); }

/** unpack the differences to this object from storage. */
inline void unPackDataDiff(dueca::AmorphReStore& s,
                           dueca::EntryCountResult& o)
{ o.unPackDataDiff(s); }
#endif

namespace std {
/** print to a stream. */
inline std::ostream &
operator << (std::ostream& s, const dueca::EntryCountResult& o)
{ return o.print(s); }
};

// specialization of classname
template<>
const char* dueca::getclassname<dueca::EntryCountResult>();
template <>
inline const char* dueca::getclassname<const dueca::EntryCountResult>()
{ return dueca::getclassname<dueca::EntryCountResult>(); }

#if !defined(__DCO_STANDALONE)
namespace dueca {
/** Template specialization, defines a trait that is needed if
    EntryCountResult is ever used inside other dco objects. */
template <>
struct dco_nested<dueca::EntryCountResult> : public dco_isnested { };
};

#endif


