/* ------------------------------------------------------------------ */
/*      item            : SyncReportRequest.hxx
        generated by    : Autobuild (abuild)
        date            : Fri 07 Mar 2025
        category        : header file
        description     : DUECA Communication Object (DCO)
                          automatically generated by dueca-codegen
        codegen version : 111
        language        : C++
        item            : SyncReportRequest.dco
        made by         : Rene' van Paassen
        date            : 1301002
        description     : Report on synchronisation state
        copyright       : (c) 2016-2022 TUDelft-AE-C&S
                        : (c) 2022 René van Paassen
        license         : EUPL-1.2
*/

#pragma once
#if !defined(__DCO_NOPACK)
namespace dueca {
class AmorphStore;
class AmorphReStore;
struct DataWriterArraySize;
};
#endif

#if !defined(__DCO_STANDALONE)
namespace dueca {
struct CommObjectDataTable;
};

#include <gencodegen.h>
#if GENCODEGEN != 111
#error "Generated SyncReportRequest.hxx too old, please clean with 'make mrproper'"
#endif
#include <dueca/CommObjectTraits.hxx>
#endif
#include <iostream>

#ifndef NESTED_DCO
#define NESTED_DCO
#define MASTER_DCO_SyncReportRequest
#endif

#ifdef MASTER_DCO_SyncReportRequest
#undef MASTER_DCO_SyncReportRequest
#undef NESTED_DCO
#endif

namespace dueca {
 
/** Request for a synchronization report
    */
struct SyncReportRequest
{
  /** typedef for internal reference */
  typedef SyncReportRequest __ThisDCOType__;

public:
  /** The name of this class. */
  static const char* const classname;


  /** if true, synchronization counters are reset */
  bool flag;

public:
  /** a "magic" number, hashed out of the class definition,
      that will be used to check consistency of the sent objects
      across the dueca nodes. */
  static const uint32_t magic_check_number;

  /** default constructor. */
  SyncReportRequest();

  /** Constructor with arguments */
  SyncReportRequest(
        const bool& flag);

  /** copy constructor. */
  SyncReportRequest(const SyncReportRequest& o);

#if !defined(__DCO_NOPACK)
  /** constructor to restore an SyncReportRequest from amorphous storage. */
  SyncReportRequest(::dueca::AmorphReStore& r);
#endif

  /** destructor. */
  ~SyncReportRequest();

#if !defined(__DCO_STANDALONE)
  /** new operator "new", which places objects not on a
      heap, but in one of the memory arenas. This to speed up
      memory management. */
  static void* operator new(size_t size);

  /** accompanying placement operator "new" */
  static void* operator new(size_t size, void* mem);

  /** new operator "delete", to go with the new version
      of operator new. */
  static void operator delete(void* p);

  /** placement "new", needed for stl. */
  inline static void* operator new(size_t size, SyncReportRequest*& o)
  { return reinterpret_cast<void*>(o); }
#endif

#if !defined(__DCO_NOPACK)
  /** packs the SyncReportRequest into amorphous storage. */
  void packData(::dueca::AmorphStore& s) const;

  /** packs the SyncReportRequest into amorphous storage.
      only differences with a previous object are packed. */
  void packDataDiff(::dueca::AmorphStore& s, const SyncReportRequest& ref) const;

  /** unpacks the SyncReportRequest from an amorphous storage. */
  void unPackData(::dueca::AmorphReStore& s);

  /** unpacks the differences for SyncReportRequest
      from an amorphous storage. */
  void unPackDataDiff(::dueca::AmorphReStore& s);
#endif

  /** Test for equality. */
  bool operator == (const SyncReportRequest& o) const;

  /** Test for inequality. */
  inline bool operator != (const SyncReportRequest& o) const
  { return !(*this == o); }

  /** Assignment operator. */
  SyncReportRequest& operator=(const SyncReportRequest& o);

  /** prints the SyncReportRequest to a stream. */
  std::ostream & print(std::ostream& s) const;
};

} 

#if !defined(__DCO_NOPACK)
/** pack the object into amorphous storage. */
inline void packData(::dueca::AmorphStore& s,
                     const dueca::SyncReportRequest& o)
{ o.packData(s); }

/** pack the differences between this object and another
    into amorphous storage. */
inline void packDataDiff(dueca::AmorphStore& s,
                         const dueca::SyncReportRequest& o,
                         const dueca::SyncReportRequest& ref)
{ o.packDataDiff(s, ref); }

/** unpack the object from amorphous storage. */
inline void unPackData(::dueca::AmorphReStore& s,
                       dueca::SyncReportRequest& o)
{ o.unPackData(s); }

/** unpack the differences to this object from storage. */
inline void unPackDataDiff(dueca::AmorphReStore& s,
                           dueca::SyncReportRequest& o)
{ o.unPackDataDiff(s); }
#endif

namespace std {
/** print to a stream. */
inline std::ostream &
operator << (std::ostream& s, const dueca::SyncReportRequest& o)
{ return o.print(s); }
};

// specialization of classname
template<>
const char* dueca::getclassname<dueca::SyncReportRequest>();
template <>
inline const char* dueca::getclassname<const dueca::SyncReportRequest>()
{ return dueca::getclassname<dueca::SyncReportRequest>(); }

#if !defined(__DCO_STANDALONE)
namespace dueca {
/** Template specialization, defines a trait that is needed if
    SyncReportRequest is ever used inside other dco objects. */
template <>
struct dco_nested<dueca::SyncReportRequest> : public dco_isnested { };
};

#endif


