/* ------------------------------------------------------------------ */
/*      item            : TimingResults.hxx
        generated by    : Autobuild (abuild)
        date            : Fri 07 Mar 2025
        category        : header file
        description     : DUECA Communication Object (DCO)
                          automatically generated by dueca-codegen
        codegen version : 111
        language        : C++
        item            : TimingResults.dco
        made by         : Rene' van Paassen
        date            : 1301002
        description     : Report on synchronisation state
        copyright       : (c) 2016-2022 TUDelft-AE-C&S
                        : (c) 2022 René van Paassen
        license         : EUPL-1.2
*/

#pragma once
#if !defined(__DCO_NOPACK)
namespace dueca {
class AmorphStore;
class AmorphReStore;
struct DataWriterArraySize;
};
#endif

#if !defined(__DCO_STANDALONE)
namespace dueca {
struct CommObjectDataTable;
};

#include <gencodegen.h>
#if GENCODEGEN != 111
#error "Generated TimingResults.hxx too old, please clean with 'make mrproper'"
#endif
#include <dueca/CommObjectTraits.hxx>
#endif
#include <iostream>

#ifndef NESTED_DCO
#define NESTED_DCO
#define MASTER_DCO_TimingResults
#endif
#include <dueca/GlobalId.hxx>
#ifdef MASTER_DCO_TimingResults
#undef MASTER_DCO_TimingResults
#undef NESTED_DCO
#endif

namespace dueca {
 
/** Report on the real-time behaviour of an Activity
    */
struct TimingResults
{
  /** typedef for internal reference */
  typedef TimingResults __ThisDCOType__;

public:
  /** The name of this class. */
  static const char* const classname;


  /** id of the module that is being timed */
  GlobalId owner_id;

  /** identification of the activity */
  uint16_t activity_no;

  /** minimum time to complete activity */
  int32_t min_complete;

  /** maximum time to complete activity */
  int32_t max_complete;

  /** average time to complete activity */
  int32_t avg_complete;

  /** minimum time to start activity */
  int32_t min_start;

  /** maximum time to start activity */
  int32_t max_start;

  /** average time to start activity */
  int32_t avg_start;

  /** number of times the completion was later than the first warning limit */
  uint16_t n_warning;

  /** number of times completion is later than second limit */
  uint16_t n_critical;

  /** number of user (module) generated warnings */
  uint16_t n_user;

public:
  /** a "magic" number, hashed out of the class definition,
      that will be used to check consistency of the sent objects
      across the dueca nodes. */
  static const uint32_t magic_check_number;

  /** default constructor. */
  TimingResults();

  /** Constructor with arguments */
  TimingResults(
        const GlobalId& owner_id,
        const uint16_t& activity_no,
        const int32_t& min_complete,
        const int32_t& max_complete,
        const int32_t& avg_complete,
        const int32_t& min_start,
        const int32_t& max_start,
        const int32_t& avg_start,
        const uint16_t& n_warning,
        const uint16_t& n_critical,
        const uint16_t& n_user);

  /** copy constructor. */
  TimingResults(const TimingResults& o);

#if !defined(__DCO_NOPACK)
  /** constructor to restore an TimingResults from amorphous storage. */
  TimingResults(::dueca::AmorphReStore& r);
#endif

  /** destructor. */
  ~TimingResults();

#if !defined(__DCO_STANDALONE)
  /** new operator "new", which places objects not on a
      heap, but in one of the memory arenas. This to speed up
      memory management. */
  static void* operator new(size_t size);

  /** accompanying placement operator "new" */
  static void* operator new(size_t size, void* mem);

  /** new operator "delete", to go with the new version
      of operator new. */
  static void operator delete(void* p);

  /** placement "new", needed for stl. */
  inline static void* operator new(size_t size, TimingResults*& o)
  { return reinterpret_cast<void*>(o); }
#endif

#if !defined(__DCO_NOPACK)
  /** packs the TimingResults into amorphous storage. */
  void packData(::dueca::AmorphStore& s) const;

  /** packs the TimingResults into amorphous storage.
      only differences with a previous object are packed. */
  void packDataDiff(::dueca::AmorphStore& s, const TimingResults& ref) const;

  /** unpacks the TimingResults from an amorphous storage. */
  void unPackData(::dueca::AmorphReStore& s);

  /** unpacks the differences for TimingResults
      from an amorphous storage. */
  void unPackDataDiff(::dueca::AmorphReStore& s);
#endif

  /** Test for equality. */
  bool operator == (const TimingResults& o) const;

  /** Test for inequality. */
  inline bool operator != (const TimingResults& o) const
  { return !(*this == o); }

  /** Assignment operator. */
  TimingResults& operator=(const TimingResults& o);

  /** prints the TimingResults to a stream. */
  std::ostream & print(std::ostream& s) const;
};

} 

#if !defined(__DCO_NOPACK)
/** pack the object into amorphous storage. */
inline void packData(::dueca::AmorphStore& s,
                     const dueca::TimingResults& o)
{ o.packData(s); }

/** pack the differences between this object and another
    into amorphous storage. */
inline void packDataDiff(dueca::AmorphStore& s,
                         const dueca::TimingResults& o,
                         const dueca::TimingResults& ref)
{ o.packDataDiff(s, ref); }

/** unpack the object from amorphous storage. */
inline void unPackData(::dueca::AmorphReStore& s,
                       dueca::TimingResults& o)
{ o.unPackData(s); }

/** unpack the differences to this object from storage. */
inline void unPackDataDiff(dueca::AmorphReStore& s,
                           dueca::TimingResults& o)
{ o.unPackDataDiff(s); }
#endif

namespace std {
/** print to a stream. */
inline std::ostream &
operator << (std::ostream& s, const dueca::TimingResults& o)
{ return o.print(s); }
};

// specialization of classname
template<>
const char* dueca::getclassname<dueca::TimingResults>();
template <>
inline const char* dueca::getclassname<const dueca::TimingResults>()
{ return dueca::getclassname<dueca::TimingResults>(); }

#if !defined(__DCO_STANDALONE)
namespace dueca {
/** Template specialization, defines a trait that is needed if
    TimingResults is ever used inside other dco objects. */
template <>
struct dco_nested<dueca::TimingResults> : public dco_isnested { };
};

#endif


