/* ------------------------------------------------------------------ */
/*      item            : IncoSpec.hxx
        generated by    : Autobuild (abuild)
        date            : Fri 07 Mar 2025
        category        : header file
        description     : DUECA Communication Object (DCO)
                          automatically generated by dueca-codegen
        codegen version : 111
        language        : C++
        item            : IncoSpec.dco
        made by         : Rene' van Paassen
        date            : 130104
        description     : Generated from a hard-coded version
        copyright       : (c) 2016-2022 TUDelft-AE-C&S
                        : (c) 2022 René van Paassen
        license         : EUPL-1.2
*/

#pragma once
#if !defined(__DCO_NOPACK)
namespace dueca {
class AmorphStore;
class AmorphReStore;
struct DataWriterArraySize;
};
#endif

#if !defined(__DCO_STANDALONE)
namespace dueca {
struct CommObjectDataTable;
};

#include <gencodegen.h>
#if GENCODEGEN != 111
#error "Generated IncoSpec.hxx too old, please clean with 'make mrproper'"
#endif
#include <dueca/CommObjectTraits.hxx>
#endif
#include <iostream>
DUECA_NS_START;
struct IncoTable;
DUECA_NS_END;
#ifndef NESTED_DCO
#define NESTED_DCO
#define MASTER_DCO_IncoSpec
#endif
#include <NameSet.hxx>
#include <vector>
#include "IncoVariable.hxx"
#ifdef MASTER_DCO_IncoSpec
#undef MASTER_DCO_IncoSpec
#undef NESTED_DCO
#endif

namespace dueca {
 
/** This is a class that specifies the initial condition calculation
    requested by a Module. It contains a list of IncoVariable
    objects. Each IncoVariable stands for a (state) variable in a
    SimulationModule that joins in the calculation of a trim condition,
    either as a target (it should attain a certain value) or as a control
    (it is manipulated so the targets attain a certain value.)
    */
struct IncoSpec
{
  /** typedef for internal reference */
  typedef IncoSpec __ThisDCOType__;

public:
  /** The name of this class. */
  static const char* const classname;


  /** The module cooperating in the inco service */
  NameSet module;

  /** A table of initial condition variables */
  std::vector<IncoVariable> table;

public:
  /** a "magic" number, hashed out of the class definition,
      that will be used to check consistency of the sent objects
      across the dueca nodes. */
  static const uint32_t magic_check_number;

  /** default constructor. */
  IncoSpec(
    size_t table_size = 0);

  /** Constructor with arguments */
  IncoSpec(
        const NameSet& module,
        const std::vector<IncoVariable>& table);

  /** copy constructor. */
  IncoSpec(const IncoSpec& o);

#if !defined(__DCO_NOPACK)
  /** constructor to restore an IncoSpec from amorphous storage. */
  IncoSpec(::dueca::AmorphReStore& r);
#endif

  /** destructor. */
  ~IncoSpec();

#if !defined(__DCO_STANDALONE)
  /** new operator "new", which places objects not on a
      heap, but in one of the memory arenas. This to speed up
      memory management. */
  static void* operator new(size_t size);

  /** accompanying placement operator "new" */
  static void* operator new(size_t size, void* mem);

  /** new operator "delete", to go with the new version
      of operator new. */
  static void operator delete(void* p);

  /** placement "new", needed for stl. */
  inline static void* operator new(size_t size, IncoSpec*& o)
  { return reinterpret_cast<void*>(o); }
#endif

#if !defined(__DCO_NOPACK)
  /** packs the IncoSpec into amorphous storage. */
  void packData(::dueca::AmorphStore& s) const;

  /** packs the IncoSpec into amorphous storage.
      only differences with a previous object are packed. */
  void packDataDiff(::dueca::AmorphStore& s, const IncoSpec& ref) const;

  /** unpacks the IncoSpec from an amorphous storage. */
  void unPackData(::dueca::AmorphReStore& s);

  /** unpacks the differences for IncoSpec
      from an amorphous storage. */
  void unPackDataDiff(::dueca::AmorphReStore& s);
#endif

  /** Test for equality. */
  bool operator == (const IncoSpec& o) const;

  /** Test for inequality. */
  inline bool operator != (const IncoSpec& o) const
  { return !(*this == o); }

  /** Assignment operator. */
  IncoSpec& operator=(const IncoSpec& o);

  /** prints the IncoSpec to a stream. */
  std::ostream & print(std::ostream& s) const;

// Additional custom code
#include "IncoSpecExtra.hxx"
};

} 

#if !defined(__DCO_NOPACK)
/** pack the object into amorphous storage. */
inline void packData(::dueca::AmorphStore& s,
                     const dueca::IncoSpec& o)
{ o.packData(s); }

/** pack the differences between this object and another
    into amorphous storage. */
inline void packDataDiff(dueca::AmorphStore& s,
                         const dueca::IncoSpec& o,
                         const dueca::IncoSpec& ref)
{ o.packDataDiff(s, ref); }

/** unpack the object from amorphous storage. */
inline void unPackData(::dueca::AmorphReStore& s,
                       dueca::IncoSpec& o)
{ o.unPackData(s); }

/** unpack the differences to this object from storage. */
inline void unPackDataDiff(dueca::AmorphReStore& s,
                           dueca::IncoSpec& o)
{ o.unPackDataDiff(s); }
#endif

namespace std {
/** print to a stream. */
inline std::ostream &
operator << (std::ostream& s, const dueca::IncoSpec& o)
{ return o.print(s); }
};

// specialization of classname
template<>
const char* dueca::getclassname<dueca::IncoSpec>();
template <>
inline const char* dueca::getclassname<const dueca::IncoSpec>()
{ return dueca::getclassname<dueca::IncoSpec>(); }

#if !defined(__DCO_STANDALONE)
namespace dueca {
/** Template specialization, defines a trait that is needed if
    IncoSpec is ever used inside other dco objects. */
template <>
struct dco_nested<dueca::IncoSpec> : public dco_isnested { };
};

#endif


