/* ------------------------------------------------------------------ */
/*      item            : ConfigFileData.hxx
        generated by    : Autobuild (abuild)
        date            : Fri 07 Mar 2025
        category        : header file
        description     : DUECA Communication Object (DCO)
                          automatically generated by dueca-codegen
        codegen version : 111
        language        : C++
        original item   : ConfigFileData.dco
        made by         : Rene' van Paassen
        date            : 200617
        description     : Simple text-based object
        copyright       : (c) 2020-2022 TUDelft-AE-C&S
                        : (c) 2022 René van Paassen
        license         : EUPL-1.2
*/

#pragma once
#if !defined(__DCO_NOPACK)
namespace dueca {
class AmorphStore;
class AmorphReStore;
struct DataWriterArraySize;
};
#endif

#if !defined(__DCO_STANDALONE)
namespace dueca {
struct CommObjectDataTable;
};

#include <gencodegen.h>
#if GENCODEGEN != 111
#error "Generated ConfigFileData.hxx too old, please clean with 'make mrproper'"
#endif
#include <dueca/CommObjectTraits.hxx>
#endif
#include <iostream>

#ifndef NESTED_DCO
#define NESTED_DCO
#define MASTER_DCO_ConfigFileData
#endif
#include <string>
#include "NameSizeDate.hxx"
#include <list>
typedef std::list<dueca::NameSizeDate> namelist_t;
#ifdef MASTER_DCO_ConfigFileData
#undef MASTER_DCO_ConfigFileData
#undef NESTED_DCO
#endif

#ifdef DUECA_CONFIG_HDF5
#include <H5Cpp.h>
#include <hdf5utils/HDF5DCOMetaFunctor.hxx>
#endif
namespace dueca {
 
/** simply transmit a single string
    */
struct ConfigFileData
{
  /** typedef for internal reference */
  typedef ConfigFileData __ThisDCOType__;

public:
  /** The name of this class. */
  static const char* const classname;


  /** name/label of the requested configuration */
  std::string name;

  /** content */
  std::string config;

  /** list data */
  namelist_t filenames;

public:
  /** a "magic" number, hashed out of the class definition,
      that will be used to check consistency of the sent objects
      across the dueca nodes. */
  static const uint32_t magic_check_number;

  /** default constructor. */
  ConfigFileData();

  /** Constructor with arguments */
  ConfigFileData(
        const std::string& name,
        const std::string& config,
        const namelist_t& filenames);

  /** copy constructor. */
  ConfigFileData(const ConfigFileData& o);

#if !defined(__DCO_NOPACK)
  /** constructor to restore an ConfigFileData from amorphous storage. */
  ConfigFileData(::dueca::AmorphReStore& r);
#endif

  /** destructor. */
  ~ConfigFileData();

#if !defined(__DCO_STANDALONE)
  /** new operator "new", which places objects not on a
      heap, but in one of the memory arenas. This to speed up
      memory management. */
  static void* operator new(size_t size);

  /** accompanying placement operator "new" */
  static void* operator new(size_t size, void* mem);

  /** new operator "delete", to go with the new version
      of operator new. */
  static void operator delete(void* p);

  /** placement "new", needed for stl. */
  inline static void* operator new(size_t size, ConfigFileData*& o)
  { return reinterpret_cast<void*>(o); }
#endif

#if !defined(__DCO_NOPACK)
  /** packs the ConfigFileData into amorphous storage. */
  void packData(::dueca::AmorphStore& s) const;

  /** packs the ConfigFileData into amorphous storage.
      only differences with a previous object are packed. */
  void packDataDiff(::dueca::AmorphStore& s, const ConfigFileData& ref) const;

  /** unpacks the ConfigFileData from an amorphous storage. */
  void unPackData(::dueca::AmorphReStore& s);

  /** unpacks the differences for ConfigFileData
      from an amorphous storage. */
  void unPackDataDiff(::dueca::AmorphReStore& s);
#endif

  /** Test for equality. */
  bool operator == (const ConfigFileData& o) const;

  /** Test for inequality. */
  inline bool operator != (const ConfigFileData& o) const
  { return !(*this == o); }

  /** Assignment operator. */
  ConfigFileData& operator=(const ConfigFileData& o);

  /** prints the ConfigFileData to a stream. */
  std::ostream & print(std::ostream& s) const;
};

} 

#if !defined(__DCO_NOPACK)
/** pack the object into amorphous storage. */
inline void packData(::dueca::AmorphStore& s,
                     const dueca::ConfigFileData& o)
{ o.packData(s); }

/** pack the differences between this object and another
    into amorphous storage. */
inline void packDataDiff(dueca::AmorphStore& s,
                         const dueca::ConfigFileData& o,
                         const dueca::ConfigFileData& ref)
{ o.packDataDiff(s, ref); }

/** unpack the object from amorphous storage. */
inline void unPackData(::dueca::AmorphReStore& s,
                       dueca::ConfigFileData& o)
{ o.unPackData(s); }

/** unpack the differences to this object from storage. */
inline void unPackDataDiff(dueca::AmorphReStore& s,
                           dueca::ConfigFileData& o)
{ o.unPackDataDiff(s); }
#endif

namespace std {
/** print to a stream. */
inline std::ostream &
operator << (std::ostream& s, const dueca::ConfigFileData& o)
{ return o.print(s); }
};

// specialization of classname
template<>
const char* dueca::getclassname<dueca::ConfigFileData>();
template <>
inline const char* dueca::getclassname<const dueca::ConfigFileData>()
{ return dueca::getclassname<dueca::ConfigFileData>(); }

#if !defined(__DCO_STANDALONE)
namespace dueca {
/** Template specialization, defines a trait that is needed if
    ConfigFileData is ever used inside other dco objects. */
template <>
struct dco_nested<dueca::ConfigFileData> : public dco_isnested { };
};

#endif

#if defined(DUECA_CONFIG_HDF5)
// functors guarded in a separate namespace
namespace ConfigFileData_space {

  // writes to file, reading from channel
  class HDF5DCOWriteFunctor: public dueca::hdf5log::HDF5DCOWriteFunctor
  {
    ConfigFileData example;
  public:
    // constructor, to be invoked by the metafunctor
    HDF5DCOWriteFunctor(std::weak_ptr<H5::H5File> file,
                        const std::string& path,
                        size_t chunksize,
                        const std::string& label,
                        bool compress, bool writeticks,
                        const dueca::DataTimeSpec* startend);

    // the functor member used by channel reading code
    bool operator() (const void* dpointer, const dueca::DataTimeSpec& ts);
  };

  // reads from file, writing to channel
  class HDF5DCOReadFunctor: public dueca::hdf5log::HDF5DCOReadFunctor
  {
    ConfigFileData example;
  public:
    // constructor, to be invoked by the metafunctor
    HDF5DCOReadFunctor(std::weak_ptr<H5::H5File> file,
                       const std::string& path,
                       bool readticks);
    // the functor member used by channel writing code
    bool operator() (void* dpointer);
  };
} // end namespace ConfigFileData_space
#endif


